# Commands.pm
# (tomw@quantium.org)
#
# Consult the file 'LICENSE' for the complete terms under which you
# may use this file.
#

use strict;

my %connected_sessions = \%main::connected_sessions;
my $tostore = \$main::tostore;

#
# Establish a connection for PORT.
#
sub doport {
    my $peeraddr = shift;
    my $port = shift;
    my $heap = shift;
    my $session = shift;

    print "[PFTPD]: Connecting to remote PORT $port\n";

    $main::connected_sessions{$session}{RSOCKET} = IO::Socket::INET->new(
                                       Proto => "tcp",
                                       PeerAddr => $peeraddr,
                                       PeerPort => $port,
                                       )
        or print "[PFTPD]: Couldnt connect to PORT $port\n";
    # Need to rw here if the port connection fails.

    $heap->{readwrite}->put("200: PORT command successful.");

    unless($main::connected_sessions{$session}{RSOCKET}) {
        print "[PFTPD]: Connected dead in do_port\n";
    }
}


#
# Establish a passive connection.
#
sub dopasv {
  my $port = shift;

  print "[PFTPD]: Listening on local port $port\n";
}

#
# Send a Listing of files
#

sub listfiles {
    my $session = shift;
    my $dirfile = shift;

    my $remote = $main::connected_sessions{$session}{RSOCKET};
    unless($main::connected_sessions{$session}{RSOCKET}) {
        print "[PFTPD]: PORT connection died.\n";
	# some cleanup fu should perhaps be done here. a print maybe.
    }

    if( -e $dirfile ) {
        if( -d $dirfile ) {
	    my $toopen = "$main::connected_sessions{$session}{CWD}" . "$dirfile";
            opendir(DIR, $toopen);
            my @files = readdir(DIR);
            foreach (@files) {
                print $remote "$main::connected_sessions{$session}{CWD}" . "$_\n";
            }
        } else {
            print $remote "$main::connected_sessions{$session}{CWD}" . "$dirfile\n";
        }
    }

    close($main::connected_sessions{$session}{RSOCKET});
}


sub get_file {
    my ($accepted_socket, $peer_address, $peer_port) = @_[ARG0, ARG1, ARG2];
 
    unless($accepted_socket) {
      print "No socket\n";
    }
   
    print $_[HEAP]->{filename} . "\n";
 
    if(sysread($accepted_socket, my $line = '', 16384)) {
	my $filehandle = $_[HEAP]->{filehandle};
	my $x = $_[SESSION];
#      if (($main::connected_sessions{$Commands::x}{PEER_ADDR}) eq $main::gameserver)
	print $filehandle $line;
    } else {
      &saysock($_[KERNEL], $_[SESSION], "226: Transfer complete.");
      $_[KERNEL]->select_read($accepted_socket);
    }
    
    close($_[HEAP]->{filehandle});
}


sub send_file {
    my ($accepted_socket, $peer_address, $peer_port) = @_[ARG0, ARG1, ARG2];

    unless($main::connected_sessions{$_[SESSION]}{RSOCKET}) {
      print "No socket\n";
    }

    print $_[HEAP]->{filename} . "\n";

    my $remote = $main::connected_sessions{$_[SESSION]}{RSOCKET};
    if(sysread($_[HEAP]->{filehandle}, my $line = '', 16384)) {
	print $remote $line;
    } else {
      &saysock($_[KERNEL], $_[SESSION], "226: Transfer complete.");
      $_[KERNEL]->select_read($_[HEAP]->{filehandle});
    }

    close($main::connected_sessions{$_[SESSION]}{RSOCKET});
}

1;




