# Misc.pm
# (tomw@quantium.org)
#
# Consult the file 'LICENSE' for the complete terms under which you
# may use this file.
#

use strict;

#
# Check the validity of a user's password.
#
sub checkpw {
    my $username = shift;
    my $password = shift;
    my ($clogin, $cpassword);

    open(SHADOW, "/etc/shadow") || die "Could not open the shadow file\n";

    while(<SHADOW>) {
        if(/$username/) {
            ($clogin, $cpassword) = split(/:/);
        }
    }
    close(SHADOW);

    if(!$clogin) { # did not find anything
        return 0;
    }
  
    my $salt = substr($cpassword, 0, 2);

    if(crypt($password, $salt) eq $cpassword) {
        return 1;
    } else {
        return 0; # This is _BAD_. You need to drop the connection _HERE_
    }
}

1;
